﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Demo_Event
{
    public delegate void PriceChangedHandler(object sender, PriceChangedEventArgs e);
    public class Product
    {
        private decimal _price;
        public event PriceChangedHandler PriceChanged;
        public decimal Price
        {
            get
            {
                return this._price;
            }
            set
            {
                if (_price == value)
                    return;
                decimal oldPrice = _price;
                _price = value;
                OnPriceChanged(new PriceChangedEventArgs(oldPrice, _price));
            }
        }

        protected virtual void OnPriceChanged(PriceChangedEventArgs e)
        {
            if (PriceChanged != null)
                PriceChanged(this, e);
        }
    }
}
